//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\registry.hpp>
#pragma hdrstop

#include "UrlsDlg.h"
#include "Global.h"
#include "FileMan.h"
#include "HelpDlg.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TUrlsForm *UrlsForm;
//---------------------------------------------------------------------------
bool __fastcall ManageURLs(TForm *owner, bool HideType2)
{
   UrlsForm = new TUrlsForm(owner);
   CenterDialog(UrlsForm,owner); UrlsForm->Top += 8;
   UrlsForm->TabSheet3->TabVisible = !HideType2;
   UrlsForm->PageControl1->ActivePage = UrlsForm->TabSheet1;
   UrlsForm->ShowModal();
   bool ok = UrlsForm->ModalResult == mrOk;
   delete UrlsForm;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TUrlsForm::TUrlsForm(TComponent* Owner)
  : TForm(Owner)
{
   GetAppData(Memo1->Lines,StatsURLs+PS+MListTxt);
   GetAppData(Memo2->Lines,StatsURLs+PS+MRingTxt);
   GetAppData(Memo3->Lines,StatsURLs+PS+MTyp2Txt);
   GetAppData(Memo4->Lines,StatsURLs+PS+CListTxt);
   GetAppData(Memo5->Lines,StatsURLs+PS+CRingTxt);
/*
   GetAppData(Memo1->Lines,"Statistics URLs"+PS+MListTxt);
   GetAppData(Memo2->Lines,"Statistics URLs"+PS+MRingTxt);
   GetAppData(Memo3->Lines,"Statistics URLs"+PS+MTyp2Txt);
   GetAppData(Memo4->Lines,"Statistics URLs"+PS+CListTxt);
   GetAppData(Memo5->Lines,"Statistics URLs"+PS+CRingTxt);
*/
// Memo1->Font->Name = GetAppIni("FontName","Courier New");
// Memo1->Font->Size = GetAppIni("FontSize","").ToIntDef(10);

// TIni*File *ini = new TIni*File(AppIni);
// Memo1->Font->Name = ini->ReadString("main","FontName","Courier New");
// Memo1->Font->Size = ini->ReadInteger("main","FontSize",10);
// delete ini;

   Memo2->Font->Name = Memo1->Font->Name;
   Memo2->Font->Size = Memo1->Font->Size;
   Memo3->Font->Name = Memo1->Font->Name;
   Memo3->Font->Size = Memo1->Font->Size;
   Memo4->Font->Name = Memo1->Font->Name;
   Memo4->Font->Size = Memo1->Font->Size;
   Memo5->Font->Name = Memo1->Font->Name;
   Memo5->Font->Size = Memo1->Font->Size;
   
   PageControl1->ActivePage = TabSheet1;
   ActiveControl = Memo1;
}
//---------------------------------------------------------------------------
void __fastcall TUrlsForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrCancel) return;

   PutAppData(StatsURLs+PS+MListTxt,Memo1->Lines);
   PutAppData(StatsURLs+PS+MRingTxt,Memo2->Lines);
   PutAppData(StatsURLs+PS+MTyp2Txt,Memo3->Lines);
   PutAppData(StatsURLs+PS+CListTxt,Memo4->Lines);
   PutAppData(StatsURLs+PS+CRingTxt,Memo5->Lines);
}
//---------------------------------------------------------------------------
void __fastcall TUrlsForm::PageControl1Change(TObject *Sender)
{
   if (PageControl1->ActivePage==TabSheet1) ActiveControl = Memo1; else
   if (PageControl1->ActivePage==TabSheet2) ActiveControl = Memo2; else
   if (PageControl1->ActivePage==TabSheet3) ActiveControl = Memo3; else
   if (PageControl1->ActivePage==TabSheet4) ActiveControl = Memo4; else
   if (PageControl1->ActivePage==TabSheet5) ActiveControl = Memo5;
}
//---------------------------------------------------------------------------
/*
void __fastcall TUrlsForm::SetDefaultUrlFromCursor(TMemo *memo)
{
   if (!memo) return;
   int idx = memo->Perform(EM_LINEFROMCHAR,(WORD)memo->SelStart,0);
   if (idx>=1 && idx<memo->Lines->Count)
   {
      memo->Lines->Insert(0,"");
      Application->ProcessMessages();
      Sleep(200);
      AnsiString line = memo->Lines->Strings[idx+1];
      memo->Lines->Strings[idx+1] = "";
      Application->ProcessMessages();
      Sleep(200);
      memo->Lines->Strings[0] = line;
      Application->ProcessMessages();
      Sleep(200);
      memo->Lines->Delete(idx+1);
      Application->ProcessMessages();
      Sleep(200);
      memo->SelStart = 0;
   }
}
*/
void __fastcall TUrlsForm::SetDefaultUrlFromCursor(TMemo *memo)
{
   if (!memo) return;
   int idx = memo->Perform(EM_LINEFROMCHAR,(WORD)memo->SelStart,0);
   if (idx>=1 && idx<memo->Lines->Count)
   {
      memo->Lines->Insert(0,"");
      AnsiString line = memo->Lines->Strings[idx+1];
      for (int i=1; i<=line.Length(); i++)
      {
         memo->Lines->Strings[idx+1] = line.SubString(i,64);
         memo->Lines->Strings[0] = line.SubString(1,i);
         Sleep(0);
      }
      memo->Lines->Delete(idx+1);
      memo->SelStart = 0;
   }
}

//---------------------------------------------------------------------------
void __fastcall TUrlsForm::MemoDblClick(TObject *Sender)
{
   SetDefaultUrlFromCursor(dynamic_cast<TMemo*>(Sender));
}
//---------------------------------------------------------------------------
void __fastcall TUrlsForm::HeplBtnClick(TObject *Sender)
{
   OpenHelp("RemailerUrl","Remailer Documents URLs","URL Manager",Application->MainForm);

}
//---------------------------------------------------------------------------