//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "pgpmail.h"
#include "global.h"
HINSTANCE hPgpLib=NULL;
//---------------------------------------------------------------------------
bool __fastcall HasPgp()
{
   return hPgpLib!=NULL;
}
//---------------------------------------------------------------------------
void  __fastcall PgpInit(HINSTANCE HMixLib, HINSTANCE HSSLLib, TForm *MainForm,
   HWND AppHandle)
{
   PGPINIT pgpinit;
   if ((pgpinit = (PGPINIT)GetProcAddress(hPgpLib,"@PgpInit"))!=NULL)
      (pgpinit)(HMixLib,HSSLLib,MainForm,AppHandle);
}
//---------------------------------------------------------------------------
bool  __fastcall PgpImportKeysReplace(char *importfile, char *pubring,
   char *secring, bool deleteImportfile)
{
   PGP_IMPORTREPLACE pgp_importreplace;
   if ((pgp_importreplace = (PGP_IMPORTREPLACE)GetProcAddress(hPgpLib,"@PgpImportKeysReplace"))!=NULL)
      return (bool)(pgp_importreplace)(importfile,pubring,secring,deleteImportfile);
   return false;
}
//---------------------------------------------------------------------------
bool  __fastcall PgpImportKeysAddNew(char *importfile, char *pubring,
   char *secring, bool deleteImportfile)
{
   PGP_IMPORTADDNEW pgp_importaddnew;
   if ((pgp_importaddnew = (PGP_IMPORTADDNEW)GetProcAddress(hPgpLib,"@PgpImportKeysAddNew"))!=NULL)
      return (bool)(pgp_importaddnew)(importfile,pubring,secring,deleteImportfile);
   return false;
}
//---------------------------------------------------------------------------
char* __fastcall PgpSignMessage(char *Message)
{
   PGP_SIGNMESSAGE pgp_signmessage;
   if ((pgp_signmessage = (PGP_SIGNMESSAGE)GetProcAddress(hPgpLib,"@PgpSignMessage"))!=NULL)
      return (char*)(pgp_signmessage)(Message);
   return NULL;
}
//---------------------------------------------------------------------------
char* __fastcall PgpEncryptMessage(char *Message)
{
   PGP_ENCRYPTMESSAGE pgp_encryptmessage;
   if ((pgp_encryptmessage = (PGP_ENCRYPTMESSAGE)GetProcAddress(hPgpLib,"@PgpEncryptMessage"))!=NULL)
      return (char*)(pgp_encryptmessage)(Message);
   return NULL;
}
//---------------------------------------------------------------------------
char* __fastcall PgpEncryptSignMessage(char *Message)
{
   PGP_ENCRYPTSIGNMESSAGE pgp_encryptsignmessage;
   if ((pgp_encryptsignmessage = (PGP_ENCRYPTSIGNMESSAGE)GetProcAddress(hPgpLib,"@PgpEncryptSignMessage"))!=NULL)
      return (char*)(pgp_encryptsignmessage)(Message);
   return NULL;
}
//---------------------------------------------------------------------------
char* __fastcall PgpGetUserIdsKeyIds(char *KeyFile)
{
   PGP_GETKEYS_IDS pgp_getkeys_ids;
   if ((pgp_getkeys_ids = (PGP_GETKEYS_IDS)GetProcAddress(hPgpLib,"@PgpGetUserIdsKeyIds"))!=NULL)
      return (char*)(pgp_getkeys_ids)(KeyFile);
   return NULL;
}
//---------------------------------------------------------------------------
/*bool  __fastcall GenerateType1List(char *KeyDoc)
{
   GENERATETYPE1LIST generatetype1list;
   if ((generatetype1list = (GENERATETYPE1LIST)GetProcAddress(hPgpLib,"@GenerateType1List"))!=NULL)
      return (generatetype1list)(KeyDoc);
   return NULL;
}*/
//---------------------------------------------------------------------------
char* __fastcall PgpGetNewRemailerKeys(char *KeyDoc, char *Type1)
{
   PGP_GETNEWKEYS pgp_getnewkeys;
   if ((pgp_getnewkeys = (PGP_GETNEWKEYS)GetProcAddress(hPgpLib,"@PgpGetNewRemailerKeys"))!=NULL)
      return (pgp_getnewkeys)(KeyDoc,Type1);
   return NULL;
}
//---------------------------------------------------------------------------
char* __fastcall PgpAddNewRemailerKeys(char *KeyDoc, char *Type1)
{
   PGP_ADDNEWKEYS pgp_addnewkeys;
   if ((pgp_addnewkeys = (PGP_ADDNEWKEYS)GetProcAddress(hPgpLib,"@PgpAddNewRemailerKeys"))!=NULL)
      return (pgp_addnewkeys)(KeyDoc,Type1);
   return "";
}
//---------------------------------------------------------------------------
char* __fastcall PgpArmorBlockToArmorKeys(char *Keys)
{
   PGP_GETARMORKEYS pgp_getarmorkeys;
   if ((pgp_getarmorkeys = (PGP_GETARMORKEYS)GetProcAddress(hPgpLib,"@PgpArmorBlockToArmorKeys"))!=NULL)
      return (pgp_getarmorkeys)(Keys);
   return "";
}
//---------------------------------------------------------------------------
char* __fastcall PgpArmorKeysToArmorBlock(char *Keys)
{
   PGP_PUTARMORKEYS pgp_putarmorkeys;
   if ((pgp_putarmorkeys = (PGP_PUTARMORKEYS)GetProcAddress(hPgpLib,"@PgpArmorKeysToArmorBlock"))!=NULL)
      return (pgp_putarmorkeys)(Keys);
   return "";
}
//---------------------------------------------------------------------------
char* __fastcall GetPgpLibName()
{
   GET_PGPLIBNAME getpgplibname;
   if ((getpgplibname = (GET_PGPLIBNAME)GetProcAddress(hPgpLib,"@GetPgpLibName"))!=NULL)
      return (getpgplibname)();
   return "";
}
//---------------------------------------------------------------------------
char* __fastcall GetPgpLibVersion()
{
   GET_PGPLIBVERSION getpgplibversion;
   if ((getpgplibversion = (GET_PGPLIBVERSION)GetProcAddress(hPgpLib,"@GetPgpLibVersion"))!=NULL)
      return (getpgplibversion)();
   return "";
}
//---------------------------------------------------------------------------



