//---------------------------------------------------------------------------
#ifndef HelpDlgH
#define HelpDlgH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Menus.hpp>
//---------------------------------------------------------------------------
void __fastcall OpenHelp(AnsiString &Section, AnsiString &Title,
   AnsiString &ActiveTab, TForm *Owner);

class THlpDlg : public TForm
{
__published:	// IDE-managed Components
  TPopupMenu *PopupMenu1;
  TMenuItem *Print1;
  TPanel *Panel2;
  TTabControl *TabControl1;
  TRichEdit *HelpText;
  TPanel *Panel1;
  void __fastcall FormPaint(TObject *Sender);
  
  void __fastcall TabControl1Change(TObject *Sender);
  void __fastcall Print1Click(TObject *Sender);
  void __fastcall TabControl1Changing(TObject *Sender, bool &AllowChange);

  void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
public:		// User declarations
  int *TopLine;
  TStrings *Tabs;
  TStringList *tabs;
  AnsiString Section;
  virtual __fastcall THlpDlg(TComponent* Owner);
  virtual __fastcall THlpDlg(AnsiString &Section, AnsiString &Title,
     AnsiString &ActiveTab,TComponent* Owner);
  __fastcall ~THlpDlg();
  void __fastcall LoadPage(int Index);
};
//---------------------------------------------------------------------------
extern THlpDlg *HlpDlg;
//---------------------------------------------------------------------------
#endif
